// Copyright 2016 concept3D, Inc.

$(document).ready(function() {

  //disable_context_menu(); // TODO: not sure if we need this
  //disable_select(); // TODO: not sure if we need this
  //hook_up_default_button(); // TODO: not sure if we need this

  load_qa();  //from mapspacer.js: must be done before startAccordions()

  startAccordions();
  startPagination();
  startMenus();
  addMedia();
});


function updatePagination() {
  startPagination();
}

/* Initiate the accordion styles */
function startAccordions() {
  var icons = {
      header: "ui-icon-circle-arrow-e",
      activeHeader: "ui-icon-circle-arrow-s"
    };

  $( ".accordion" ).accordion({
      collapsible: true,
      header: "> div.title",
      icons: icons,
      heightStyle: "content"
    });

  $( ".ui-accordion-header" ).click(function(ev){
      ev.preventDefault();
      ev.stopPropagation();
      console.log("stopping propagation");
    });

  $( ".accordion" ).find('span').click(function(ev){
      var $obj = $(this);
      console.log($obj);
      console.log($obj.parent());
     // $obj.parent().click();
    });

  $( "#qa-section" ).accordion({
    collapsible: true,
    header: "h3.question",
    icons: icons,
    heightStyle: "content"
  });

}

/* Initiate the pagination elements */
function startPagination() {

  $('#content .room-set-pagination').pajinate({
    items_per_page : 4,
    num_page_links_to_display : 0,
    show_first_last : false,
    nav_label_next : "",
    nav_label_prev : "",
    item_container_id : '.room-set-inner'
  });
  $('#content .media-inner').pajinate({
    items_per_page : 4,
    num_page_links_to_display : 0,
    show_first_last : false,
    nav_label_next : "",
    nav_label_prev : "",
    item_container_id : '.icons'
  });
  $('#content .components-inner').pajinate({
    items_per_page : 4,
    num_page_links_to_display : 0,
    show_first_last : false,
    nav_label_next : "",
    nav_label_prev : "",
    item_container_id : '.icons'
  });

}

/* Initiate the pullout menus in the sidebar */
function startMenus() {
  $( ".sidebar-menu" ).menu({
    position: { at: "left+61 top" }
  });

//  $( ".sidebar-menu" ).on("mouseout", function(){
//      $(".sidebar-menu").menu("collapse");
//  });
} 

/* Get all the images from the RFP dir and place thumbnails here */
function addMedia() {
$.ajax({
  url: "../RFP/",
  success: function(data){
    console.log("success");

     $(data).find("a:contains(.jpg)").each(function(){
        // will loop through 
        var images = $(this).attr("href");

        $('<button></button>').html(images).prependTo('.media .icons');

     });
  }
});
}


/* Toggles sections of the menu by turning off
 * all other menu sections, then turning on e.currentTarget.name,
 * then hiding the menu.
 */
function toggleMenu() {
  $( '.menu-selectable-section' ).hide();
  $( '#menu-window' ).toggle( 'slow' );
  $( '#overlay' ).toggleClass('behind-menu');
}

function toggleMenuItem(e) {
  section = e.currentTarget.name;
  $( '.menu-selectable-section' ).hide();
  $( '#'+section ).show( 'slow' );
}

function backToMain() {
  $( '.menu-selectable-section' ).hide();
}


/* Disables the context menu with the exception for textboxes in order to
 * mimic native windows.
 */
function disable_context_menu() {
  $(document).on('contextmenu', function(e) {
    return $(e.currentTarget).is('input[type=text], input[type=email], input[type=password], textarea');
  });
}


/* Disables text selection on elements other than input type elements where
 * it makes sense to allow selections. This mimics native windows.
 */
function disable_select() {
  $(document).on('mousedown selectstart', function(e) {
    return $(e.currentTarget).is('input, textarea, select, option');
  });
}


// TODO: not sure if we need this
var KEYCODE_ENTER = 13;
function hook_up_default_button() {
  var $default_button = $("button[type=submit]");
  if ($default_button.length == 1) {

    $(document).keypress(function (event) {
      if (event.which == KEYCODE_ENTER) {
        $default_button.trigger('click');
        event.preventDefault();
        event.stopPropagation();
        return false;
      }
    });

  }
}
